require 'test_helper'

module Workarea
  class Registry
    class PublicSearchTest < TestCase
      setup :registry

      def email
        'test@workarea.com'
      end

      def registry_name
        'Test Registry'
      end

      def another_email
        'test-other@workarea.com'
      end

      def registry
        @registry ||= create_registry(
          email:      email,
          name:       registry_name
        )
      end

      def test_results
        search = Workarea::Registry::PublicSearch.new(registry_name)
        assert_equal([registry], search.results.to_a)

        search = Workarea::Registry::PublicSearch.new(email)
        assert_equal([registry], search.results.to_a)

        search = Workarea::Registry::PublicSearch.new(another_email)
        assert_empty(search.results)

        search = Workarea::Registry::PublicSearch.new('bogus')
        assert(search.results.to_a.empty?)

        registry.update_attributes(privacy: 'private')
        assert(Workarea::Registry::PublicSearch.new(registry_name).results.empty?)

        registry.update_attributes(privacy: 'shared')
        assert(Workarea::Registry::PublicSearch.new(registry_name).results.empty?)
      end
    end
  end
end
